﻿using AppLauncher.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AppLauncher
{
    public partial class MainForm : AForm
    {

        public MainForm() : base()
        {
            InitializeComponent();


        }

        private async void button1_Click(object sender, EventArgs e)
        {
            if (this.Width > 40)
            {
                await collapseWindow(40, 6);
            }
            else
            {
                await expandWindow(800, 8);
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            //ProcessStartInfo process = new ProcessStartInfo();
            //process.FileName = @"C:\B\Portable Files (pure)\Build and Deploy Utility\v0.2.0.046 alpha\badutil.exe";
            //process.Arguments = "";
            //process.WindowStyle = ProcessWindowStyle.Normal;
            //process.Verb = "runas";
            //Process.Start(process);

            //richTextBox1.Text += tilePanelContainer1.GridSize.ToString() + Environment.NewLine;

            tilePanelContainer1.Controls.Add(tilePanel1);
            tilePanel1.Location = new Point(0, 0);

            tilePanelContainer1.Controls.Add(tilePanel2);
            tilePanel2.Location = new Point(0, 0);





        }

        protected async Task collapseWindow(int width, int increment = 8)
        {
            await Task.Run(() =>
            {
                while (this.Width > width)
                {
                    if (this.InvokeRequired)
                    {
                        this.Invoke(new MethodInvoker(() => {
                            this.Width -= increment;
                        }));
                    }
                    else
                    {
                        this.Width -= increment;
                    }

                    Application.DoEvents();
                }
            });
        }

        protected async Task expandWindow(int width, int increment = 8)
        {
            await Task.Run(() =>
            {
                while (this.Width < width)
                {
                    if (this.InvokeRequired)
                    {
                        this.Invoke(new MethodInvoker(() => {
                            this.Width += increment;
                            this.Invalidate();
                        }));
                    }
                    else
                    {
                        this.Width += increment;
                        this.Invalidate();
                    }

                    Application.DoEvents();
                }
            });
        }

        //private void Form1_MouseDown(object sender, MouseEventArgs e)
        //{
        //    const int WM_NCLBUTTONDOWN = 0xA1;
        //    const int HT_CAPTION = 0x2;

        //    this.Capture = false;

        //    Message msg = Message.Create(this.Handle, WM_NCLBUTTONDOWN, (IntPtr)HT_CAPTION, IntPtr.Zero);

        //    WndProc(ref msg);
        //}

    }
}
