﻿using System.ComponentModel;

namespace AppLauncher.Windows.Forms
{
    public partial class HeadingPanel : AUserControl
    {
        protected bool isChecked = false;

        public HeadingPanel() : base()
        {
            InitializeComponent();

            this.Checked = false;
        }

        [Category("Appearance"), Browsable(true)]
        public string TitleText { get => label1.Text; set => label1.Text = value; }

        [Category("Appearance"), Browsable(true)]
        public bool Checked
        {
            get => isChecked;
            set
            {
                isChecked = value;

                pictureBox1.BackgroundImage = (value) ? Properties.Resources.toggle_right_ea_16 : Properties.Resources.toggle_left_ea_16;
            }
        }

    }
}
